package dev.fitko.fitconnect.client.sender.steps.encrypted;

import dev.fitko.fitconnect.client.sender.model.SendableEncryptedSubmission;

import java.util.Map;
import java.util.UUID;

public interface EncryptedAttachmentsStep {

    /**
     * Add a list of encrypted attachments to the submission to send.
     *
     * @param attachments map of attachment-uuid on encrypted attachment content
     *
     * @return the next step where additional encrypted data can be added to the submission
     */
    EncryptedAttachmentsStep addEncryptedAttachments(Map<UUID, String> attachments);

    /**
     * Add an encrypted attachment to the submission to send.
     *
     * @param id UUID of the attachment to add
     * @param content the encrypted attachment content
     * @return the next step where additional data can be added to the submission
     */
    EncryptedAttachmentsStep addEncryptedAttachment(UUID id, String content);

    SendableEncryptedSubmission build();
}
